#include <stdio.h>
#include <stdlib.h>
#include "othello.h"

void PrintFLResult(int **result, int num)
{
  int i, j;
  int *total;
  int *vic[3];

  total = (int *)calloc(num, sizeof(int));
  if(total == NULL){
    printf("othello: Not enough memory (;_;)/\n");
    exit (-1);
  }

  for(i = 0; i < 3; i++){
    vic[i] = (int *)calloc(num, sizeof(int));
    if(vic[i] == NULL){
      printf("othello: Not enough memory (;_;)/\n");
      exit (-1);
    }
  }
    
  for(i = 0; i < num; i++)
    for(j = 0; j < num; j++){
      total[i] += (result[j][i] - result[i][j]);
      if(i != j){
	if(result[i][j] < 0){ /* j()餱(i()ξ) */
	  vic[1][i]++;
	  vic[0][j]++;
	}else if(result[i][j] > 0){ /* i()餱(j()ξ) */
	  vic[0][i]++;
	  vic[1][j]++;
	}else{ /* ʬ */
	  vic[2][i]++;
	  vic[2][j]++;
	}
      }
    }

  printf("");
  for(i = 0; i < (num - 1); i++)
    printf("");
  printf("\n");

  printf("WB");
  for(i = 0; i < num; i++)
    printf("%s", e_list[i + 1].Lname);
  printf("\n");

  printf("");
  for(j = 0; j < (num - 1); j++)
    printf("");
  printf("\n");
  
  for(i = 0; i < num; i++){
    printf("%s", e_list[(i + 1)].Lname);
    for(j = 0; j < num; j++)
      if(i == j)
	printf("㨢");
      else
	printf("% 4d", result[i][j]);
    printf("\n");
    if(i < (num - 1)){
      printf("");
      for(j = 0; j < (num - 1); j++)
	printf("");
      printf("\n");
    }else{
      printf("");
      for(j = 0; j < (num - 1); j++)
	printf("");
      printf("\n");
    }
  }

  for(i = 0; i < num; i++)
    printf("%-10s:% 4d %2d%2d%2dʬ\n", e_list[i + 1].name, total[i],
	   vic[0][i], vic[1][i], vic[2][i]);
}

void PrintSLResult(int **result, int num, int key)
{
  int i, j, k, f, count;
  int start, end;
  int total;
  int vic[3];

  count = (num - 1) / 11 + 1;

  total = 0;
  start = 0;
  end = 11;
  f = 0;
  vic[0] = vic[1] = vic[2] = 0;

  for(k = 0; k < count; k++){
    if(num < end)
      end = num;

    printf("");
    for(i = start; i < (end - 1); i++)
      printf("");
    printf("\n");
    
    printf("Ũ");
    for(i = start; i < end; i++){
      if(i == key)
	f = 1;
      printf("%s", e_list[i + 1 + f].Lname);
    }
    printf("\n");
    
    printf("");
    for(j = start; j < (end - 1); j++)
      printf("");
    printf("\n");
    
    printf("%s", e_list[key + 1].Lname);
    for(j = start; j < end; j++)
      printf("% 4d", result[0][j]);
    printf("\n");
    
    printf("");
    for(j = start; j < (end - 1); j++)
      printf("");
    printf("\n");
    
    printf("%s", e_list[key + 1].Lname);
    for(j = start; j < end; j++)
      printf("% 4d", result[1][j]);
    printf("\n");
    
    printf("");
    for(j = start; j < (end - 1); j++)
      printf("");
    printf("\n");

    start += 11;
    end += 11;
  }
  for(i = 0; i < num; i++){
    total += (result[0][i] - result[1][i]);
    if(result[0][i] < 0) /* 餱 */
      vic[0]++;
    else if(result[0][i] > 0) /*  */
      vic[1]++;
    else /* ʬ */
      vic[2]++;
    if(result[1][i] < 0) /*  */
      vic[1]++;
    else if(result[1][i] > 0) /* 餱 */
      vic[0]++;
    else /* ʬ */
      vic[2]++;
  }
    
  printf("%-10s:% 4d %2d%2d%2dʬ\n", e_list[key + 1].name, total,
	 vic[0], vic[1], vic[2]);
}
